<svelte:window on:keydown="pageScrollKey(event)" />

<div class="message-area">
  <div ref:messageList
       class="message-list"
       on:scroll="onScroll(event, channelMessages, $channel.id, capHit)">
    {#if channelMessages}
    {#each channelMessages as message ((message.nonce || message.id))}
    <div class="message-container">
      <Message id={message.id}
               content={message.content}
               gameId={message.gameId}
               gameOptions={message.gameOptions}
               displayName={message.authorDisplayName}
               authorId={message.authorId}
               createdAt={message.createdAt}
               attachments={message.attachments}
               embeds={message.embeds}
               on:attachmentLoad="jumpBottom(true)"
               on:edit="set({editing: event})"
               on:setGame="set({game: event.game, gameOptions: event.options})"
               editing={editing && editing == message.id} />
    </div>
    {/each}
    {/if}
  </div>

  {#if dragging}
  <div class="drag-popover">
    <div class="drag-text">
      Drop your files!
    </div>
  </div>
  {/if}

  <ChannelInput
    on:edit="set({editing:event})"
    {lastOwnMessageId}
    messages={channelMessages}
    isChannelInput=true
    messageContent=""
    channelId={$channel.id}
    on:messageSent="jumpBottom()"
    on:stickToBottom="jumpBottom(true)"
    bind:files
    bind:game
    bind:gameOptions
    channelName={$channel.name} />
</div>

<script>
  import Message from "./Message.svelte";
  import ChannelInput from "./ChannelInput.svelte";
  import ChannelMessageStore from "../stores/ChannelMessageStore";

  // const noNonces = new Set();
  
  export default {
    data() {
      return {
        files: []
      };
    },
    components: {
      Message,
      ChannelInput
    },
    computed: {
      lastOwnMessageId({$userId, channelMessages}) {
        let lastOwnMessage = null;
        if (channelMessages) {
          // We really need to figure out how to cache this
          for (let i = channelMessages.length - 1; i != -1; i--) {
            console.log(i, "wooo", channelMessages);
            const message = channelMessages[i];
            if (message.authorId == $userId) {
              lastOwnMessage = message;
              break;
            }
          }
        }
        return lastOwnMessage && lastOwnMessage.id;
      }
    },
    methods: {
      onDrop(ev) {
        console.log("onDrop", ev.dataTransfer.files);
        const diff = {dragging: false};
        if (ev.dataTransfer.files.length) {
          const files = this.get().files;
          diff.files = files.concat(Array.from(ev.dataTransfer.files));
        }
        this.set(diff);
      },
      dragOver(ev) {
        if (Array.from(ev.dataTransfer.items).find(item => item.kind == "file")) {
          ev.preventDefault();
          this.set({dragging: true});
        }
      },
      dragLeave(ev) {
        console.log(ev);
        if (ev.screenX == 0 && ev.screenY == 0) {
          this.set({dragging: false});
        }
      },
      async messagesChange() {
        if (this._changing) return;
        this._changing = true;
        setTimeout(() => {
          const got = this.get();
          const messages = ChannelMessageStore.getItems(got.channelId);
          console.log(
            "scroll messagesChange()",
            messages.length,
            "FROM.",
            got.channelMessages && got.channelMessages.length
          );

          this.set({
            channelMessages: messages
          });
          this._changing = false;
        });
      },
      // TODO: Figure out wtf to do about key repeats?!
      pageScrollKey(event) {
        const code = event.which || event.keyCode;
        const delta = code == 33 ? -1 : code == 34 ? 1 : 0;
        if (
          delta &&
          ((event.repeat && !this.get().runningScroll) || !event.repeat)
        ) {
          // wtf crazy math
          const top =
            this.refs.messageList.clientHeight *
            delta *
            (event.repeat ? 0.8 : 0.9);
          console.log(
            "SCROLLING....",
            event.key,
            delta,
            top,
            this.refs.messageList.clientHeight
          );
          this.set({runningScroll: true});
          console.log("scrollBy()");
          this.refs.messageList.scrollBy({
            top,
            left: 0,
            behavior: "smooth" // event.repeat ? "auto" : "smooth"
          });
          setTimeout(() => this.set({runningScroll: false}), 200);
        }
      },
      jumpBottom(checkStuck, fast) {
        if (checkStuck && this.get().scrolledPast) return;
        this.set({scrolledPast: false});
        console.log("Jumping past!");
        console.log("scroll()", new Error("wha?"));
        this.refs.messageList.scroll({
          top: this.refs.messageList.scrollHeight,
          left: 0,
          behavior: fast ? "auto" : "smooth"
        });
      },
      async onScroll(event, messages, channelId, capHit) {
        if (
          this.refs.messageList.scrollTop + this.refs.messageList.clientHeight >=
          this.refs.messageList.scrollHeight
        )
          this.set({scrolledPast: false});
        else {
          this.set({scrolledPast: true});
        }
        if (this.refs.messageList.scrollTop == 0 && messages.length && !capHit) {
          console.log("fetching & slurping more messages...");
          const results = await ChannelMessageStore.fetch(
            channelId,
            `?before=${messages[0].id}`
          );
          if (results.length < 50) this.set({capHit: true});
        }
      }
    },
    onupdate({current, changed}) {
      if (changed.channelMessages) {
        console.log("Jumping!", current.scrolledPast);
        const scrollHeight = this.refs.messageList.scrollHeight;
        if (!current.scrolledPast) {
          this.jumpBottom(false, true);
        } else {
          // heck this.
          const scrollTop = scrollHeight - this._scrollHeight;
          console.log(
            "scrollTopDiff",
            scrollTop,
            this.refs.messageList.scrollTop
          );
          this.refs.messageList.scrollTop += scrollTop;
        }
        this._scrollHeight = scrollHeight;
      }
    },
    async onstate({current, changed}) {
      console.log("app modified!", current, changed);
      if (current.channelId && changed.channelId) {
        ChannelMessageStore.subscribeComponent(
          current.channelId,
          this,
          this.messagesChange,
          "c"
        ).then(() => this.jumpBottom(false, true));
      }
    },
    async oncreate() {
      window.messageArea = this;
    }
  };
</script>


<style>
  .message-list {
    margin-top: auto;
    max-height: 100vh;
    overflow-y: auto;
    width: 100%;
  }


  .message-area {
    display: flex;
    height: 100%;
    flex-direction: column;
    position: relative;
  }

  .drag-popover {
    position: absolute;
    top: 0;
    bottom: 0;
    left: 0;
    right: 0;
    height: 100%;
    width: 100%;
  }

  .drag-text {
    text-align: center;
    line-height: 100vh;
    font-size: 2em;
    background: #0005;
    padding: 0.5em;
    font-weight: 600;
  }
</style>
